/*
 * PM - 2017
 * lab0.c
 */

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		75

#define NUM_NOTE		8
#define PAROLA 1234

#include "spi.h"
#include "ST7735R_TFT.h"
#include "usart.h"

// note pt speaker
int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523
};

volatile int build_pass = 0;
volatile int count_press_btn = 0;
volatile int sec = 0;
volatile int secunde = 0;
volatile int blocked_var = 0;
int parola;
int armed = 0;
int wrong_pass_no = 0;
static const char *spaces = "                                                       ";
char buf[80];


/* La intrerupere de butoane compune parola in build_pass */
ISR(PCINT2_vect)
{
    if ((PINC & (1 << PC0)) == 0)
    {
        if ((PORTD & (1 << PD7)) == 0){
			PORTD |= (1 << PD7);
		}else{
			PORTD &= ~(1 << PD7);
		}
	
		
    }
	else if ((PINC & (1 << PC1)) == 0 && blocked_var == 0)
    {	
		build_pass = build_pass * 10 + 1;
		count_press_btn = count_press_btn + 1;
		sprintf(buf, "%d", build_pass);
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(53, 100, buf, 255, 255, 255, 0, 0, 0);
		_delay_ms(250);
    }
	else if ((PINC & (1 << PC2)) == 0 && blocked_var == 0)
    {	
		build_pass = build_pass * 10 + 2;
		count_press_btn = count_press_btn + 1;
		sprintf(buf, "%d", build_pass);
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(53, 100, buf, 255, 255, 255, 0, 0, 0);
		_delay_ms(250);
    }
	else if ((PINC & (1 << PC3)) == 0 && blocked_var == 0)
    {	
		build_pass = build_pass * 10 + 3;
		count_press_btn = count_press_btn + 1;
		sprintf(buf, "%d", build_pass);
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(53, 100, buf, 255, 255, 255, 0, 0, 0);
		_delay_ms(250);
    }
	else if ((PINC & (1 << PC4)) == 0 && blocked_var == 0)
    {		
		build_pass = build_pass * 10 + 4;
		count_press_btn = count_press_btn + 1;
		sprintf(buf, "%d", build_pass);
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(53, 100, buf, 255, 255, 255, 0, 0, 0);
		_delay_ms(250);
    }
	
}


ISR(TIMER1_COMPA_vect)
{
    /* Start ADC conversion */
	sec++;
	if(sec == 10) {
		sec = 0;
		secunde ++;
	}
}

void TIMER1_init()
{
    /* Initializare timer pentru COMPA la 100ms */
	TCNT1 = 0;
    TCCR1B = (5 << CS10) | (1 << WGM12);
    TIMSK1 |= (1 << OCIE1A);
    OCR1A = 1561;
	
	sec = 0;
}


void init_IO(){
	
	/* Setez pinul PC0 ca intrare. */
	DDRC &= ~(1 << PC0) & ~(1 << PC1) & ~(1 << PC2) & ~(1 << PC3) & ~(1 << PC4);

	/* Activez rezistenta de pull-up pentru pinul PC0. */
	PORTC |= (1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC3) | (1 << PC4);

	/* Setez pinul PD7 ca iesire. */
	DDRD |= (1 << PD7);
	DDRD &= ~(0 << PD0);

	/* Sting LED-ul. */
	PORTD &= ~(1 << PD7);

	/* Dau drumul la intreruperi pe PC0-PC4 */
	PCICR = 0;
	PCICR |= (1 << PCIE2);
	PCMSK2 = 0;
	PCMSK2 |= (1 << PCINT16) | (1 << PCINT17) | (1 << PCINT18) | (1 << PCINT19) | (1 << PCINT20);
	
	/* Input pt senzorul de miscare(PA0) */
	DDRA |= (1 << PA0);

	
	/* PD4 - buzzer-ul */
	/* Setez pinul PD4 ca iesire. */
	DDRD |= (1 << PD4);

	/* Opresc speaker-ul. */
	PORTD &= ~(1 << PD4);
	
	
}




/* Aprinde led-ul PD7 la apasarea butonului PC0. */
void senzor_miscare(void) {
	

	secunde = 0;
	sec = 0;
	TIMER1_init();
	while(secunde < 10);
	
	DDRA &= ~(1 << PA0);
	PINA &= ~(1<< PA0);
	
	while(1){		
		if ((PINA & (1 << PA0)) != 0) {
			PORTD |= (1 << PD7);
			return ;
		}else{
			PORTD &= ~(1 << PD7);
		}
	}
	
}




/* Functia cu care canta buzzer-ul */
/* Genereaza sunetul pentru tipul de ton folosit: lung (150ms) sau scurt (50ms). */
void speaker_morse(int tip_morse) {
	int i;

	/* Alternam starea pinului PD4 la fiecare milisecunda. */
	for (i = 0; i < tip_morse; ++i) {
		PIND = (1 << PD4);

		_delay_ms(1);
	}
	
}

void make_call(){
	
		USART0_init();
	
		const char cmd1[]="AT";
		const char cmd2[]="AT+CMGF=1";
		const char cmd3[]="AT+CMGW=\"+40728838483\"\r";
		const char cmd4[]="Buna";
		const char cmd5[]="AT+CMSS=1";
		const char cmd6[]="AT+CMGD=1,4";
		char c;
	 

			
		USART0_print(cmd1);
		_delay_ms(8000);	
		
		sprintf(buf, "Trimite 1");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		USART0_print(cmd2);
		_delay_ms(8000);
		
		sprintf(buf, "Trimite 2");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		USART0_print(cmd3);
		_delay_ms(8000);
		
		sprintf(buf, "Trimite 3");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		USART0_print(cmd4);
		_delay_ms(8000);
		
		sprintf(buf, "Trimite 4");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		USART0_transmit((char)26);
		_delay_ms(8000);
		sprintf(buf, "Trimite CTRL+Z");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		
		USART0_print(cmd5);
		_delay_ms(8000);
		sprintf(buf, "Trimite 5");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		USART0_print(cmd1);
		_delay_ms(8000);
		sprintf(buf, "Trimite 1");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
		
		USART0_print(cmd6);
		_delay_ms(8000);
		sprintf(buf, "Trimite 6");
		ST7735R_DrawText(0, 100, spaces, 255, 255, 0, 0, 0, 0);
		ST7735R_DrawText(0, 100, buf, 0, 255, 255, 0, 0, 0);
	
	
	
	
}


void blocked(){
	
	make_call();
	
	int semnal = MORSE_SCURT;
	while(1){		
		speaker_morse(semnal);
		_delay_ms(MORSE_PAUZA);
		
	}
	
}

/*
 * Genereaza tonuri pentru codul Morse folosind speaker-ul. Tonul generat este
 * selectat folosind butoanele PB2 si PD6.
 */
void buzzer(void) {
	
	build_pass = 0;
	count_press_btn = 0;
	
	
	int semnal = MORSE_LUNG;
	build_pass = 0;
	count_press_btn = 0;
	secunde = 0;
	sec = 0;
	while( build_pass != parola ){
		
		if(secunde == 10){
			sprintf(buf, "ACCES RESPINS");
			ST7735R_DrawText(53, 100, spaces, 255, 255, 0, 0, 0, 0);
			ST7735R_DrawText(25, 100, buf, 255, 255, 255, 0, 0, 0);
			blocked_var = 1;
			blocked();
			
		}
		
		if (count_press_btn == 4 && build_pass != parola){
			build_pass = 0;
			count_press_btn = 0;
			wrong_pass_no++;
			if (wrong_pass_no == 3) {
				sprintf(buf, "ACCES RESPINS");
				ST7735R_DrawText(53, 100, spaces, 255, 255, 0, 0, 0, 0);
				ST7735R_DrawText(25, 100, buf, 255, 255, 255, 0, 0, 0);
				blocked_var = 1;
				blocked();
				
			}
			sprintf(buf, "PAROLA GRESITA!");
			ST7735R_DrawText(53, 100, spaces, 255, 255, 0, 0, 0, 0);
			ST7735R_DrawText(20, 130, buf, 0, 255, 255, 0, 0, 0);
			_delay_ms(1000);
			ST7735R_DrawText(20, 130, spaces, 0, 255, 255, 0, 0, 0);
			
		}

		speaker_morse(semnal);
	}
	PORTD &= ~(1 << PD4);
	
}

void asteapta_parola(){
	parola = 0;
	build_pass = 0;
	count_press_btn = 0;
	
	while(count_press_btn < 4);
	
	sprintf(buf, "ARMED");
	ST7735R_DrawText(41, 50, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(52, 50, buf, 0, 255, 255, 0, 0, 0);
	_delay_ms(500);
	ST7735R_DrawText(53, 100, spaces, 255, 255, 0, 0, 0, 0);
	 
	parola = build_pass;

	build_pass = 0;
	armed = 1;
	
	senzor_miscare();
	TIMER1_init();
	buzzer();
	
	sprintf(buf, "DISARMED");
	ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);
	ST7735R_Line(5, 60, 122, 60, 255, 255, 255);
	ST7735R_DrawText(52, 50, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(41, 50, buf, 0, 255, 255, 0, 0, 0);
	ST7735R_DrawText(0, 150, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(0, 130, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(50, 130, spaces, 255, 255, 0, 0, 0, 0);
	ST7735R_DrawText(53, 100, spaces, 255, 255, 0, 0, 0, 0);
	armed = 0;
	
	
}

void functie(){
	
	if (armed == 0) {
		asteapta_parola();
	}	
}



int main(void) {
	SREG = 0;
	SREG |= (1<<7);
	
	SPI_init();
    ST7735R_Begin();
	
	init_IO();
	sprintf(buf, "DISARMED");
	ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);
	ST7735R_DrawText(41, 50, buf, 0, 255, 255, 0, 0, 0);
	ST7735R_Line(5, 60, 122, 60, 255, 255, 255);
	USART1_init();

	while(1){
		
		functie();
		build_pass = 0;
	
	}
	
	
	
	
	

	while (1);

	return 0;
}


